/*
Feladat:
Egy kbelhlzat klnbz csatornin N filmet jtszanak. 
Ismerjk mindegyik film kezdsi s vgidejt. 
Egyszerre csak 1 filmet tudunk nzni. 
Add meg, hogy maximum hny filmet nzhetnk vgig s melyeket!
*/

#include <iostream>

using namespace std;

const int MAXN = 100;

//ra s perc
struct Ido {
	int o, p;
};

//kezd-, vgid s eredeti sorszm
struct Film {
	Ido k, v;
	int s;
};

void beolvasas(int& n, Film f[]) {
	cerr << "Filmek szama (0.." << MAXN << "):";
    //A bemenetet nem ellenrizzk sem szintaktikai, sem szemantikai szempontbl.
    cin >> n; //0<=N<=MaxN
    for (int i = 0; i < n; i++) {
		cerr << i + 1 << ". film kezdo es vegideje (ora perc):";
		cin >> f[i].k.o >> f[i].k.p >> f[i].v.o >> f[i].v.p;
		f[i].s = i + 1;
	}
}

void csere(Film& e, Film& f) {
	Film s = e;
	e = f;
	f = s;
}

void rendezes(const int& n, Film f[]) {
	for (int i = 0; i < n- 2; i++) {
		int min = i;
		for (int j = i + 1; j < n; j++) {
			if (f[min].v.o > f[j].v.o || (f[min].v.o == f[j].v.o && f[min].v.p > f[j].v.p)) {
				min = j;
			}
		}
		csere(f[i], f[min]);
	}
}

void kivalogatas(const int& n, Film f[], int& db, int x[]) {
	rendezes(n, f);//az f[1..n] befejezsi id szerint rendezse
	db = 0;
	x[db++] = f[0].s;
	int j = 0;
    for (int i = 1; i < n; i++) {
		if (f[i].k.o > f[j].v.o || (f[i].k.o == f[j].v.o && f[i].k.p > f[j].v.p)) {
			x[db++] = f[i].s;
			j = i;
		}
	}
}

void kiiras(const int& db, int x[]) {
	cerr << "A megnezendo filmek szama:";
	cout << db; 
    cerr << "A megnezendo filmek sorszama:"; 
    for (int i = 0; i < db; i++) {
		cout << x[i] << " ";
	}
    cout << endl;
}

int main() {
	
	int n, db, x[MAXN];
	Film f[MAXN];
	
	beolvasas(n, f);
	kivalogatas(n, f, db, x);
	kiiras(db, x);
	
	return 0;
	
}