//package sablon;

import java.io.IOException;
import java.lang.Math;
import java.io.PrintStream;

import mester.IO;


public class feladat {

    public feladat() {
    }

    static final int MaxN = 100;

    static class IdoPont {
        int o;  // ora
        int p;  // perc
    }
	
	static class Film {
        IdoPont k;
        IdoPont v;
        int s;  // eredeti sorszam
    }
	
	static class Input {
        int N;
        Film[] F;
    }

    static class Output {
        int Db;
		int[] X;
    }

    static Input beolvas(IO io) throws IOException {
        Input input = new Input();
        input.N = io.nextInt();
		input.F=new Film[input.N];
		for (int i=0;i<input.N;i++) {
			input.F[i]=new Film();
			input.F[i].k=new IdoPont();
			input.F[i].k.o=io.nextInt();
			input.F[i].k.p=io.nextInt();
			input.F[i].v=new IdoPont();
			input.F[i].v.o=io.nextInt();
			input.F[i].v.p=io.nextInt();
			input.F[i].s=i;
		}
        return input;
    }
	
	static void kiir(IO io, Input input, Output output) throws IOException {
		io.writeLn(output.Db);
		for (int i=0;i<output.Db;i++) {
			io.write(output.X[i]+1+" ");
		}
    }

	static void Csere(Input in,int e, int f){
		int s;
		s=in.F[e].s;
		in.F[e].s=in.F[f].s;
		in.F[f].s=s;
		
		s=in.F[e].k.o;
		in.F[e].k.o=in.F[f].k.o;
		in.F[f].k.o=s;
		
		s=in.F[e].k.p;
		in.F[e].k.p=in.F[f].k.p;
		in.F[f].k.p=s;
		
		s=in.F[e].v.o;
		in.F[e].v.o=in.F[f].v.o;
		in.F[f].v.o=s;
		
		s=in.F[e].v.p;
		in.F[e].v.p=in.F[f].v.p;
		in.F[f].v.p=s;
		
	}
	
	static void Rendezes(Input in){
		for (int i=0;i<in.N-1;i++) {
			int min=i;
			for (int j=i+1;j<in.N;j++) {
				if ((in.F[min].v.o>in.F[j].v.o) || ((in.F[min].v.o==in.F[j].v.o) && (in.F[min].v.p>in.F[j].v.p))) {
					min=j;
				}
			}
			Csere(in,i,min);
		}
	}
	
	static Output Kivalogatas(Input input) {
		Output output = new Output();
		Rendezes(input);
		output.Db=0;
		output.X=new int[input.N];
		output.X[output.Db]=input.F[0].s;
		output.Db++;
		int j=0;
		for (int i=1;i<input.N;i++) {
			if ((input.F[i].k.o>input.F[j].v.o) || ((input.F[i].k.o==input.F[j].v.o) && (input.F[i].k.p>input.F[j].v.p))) {
				output.X[output.Db]=input.F[i].s;
				output.Db++;
				j=i;
			}
		}		
		return output;
	}
   
    public static void main(String[] args) throws Exception {
        IO io = new IO();

        Input input = beolvas(io);

        Output output = Kivalogatas(input);

        kiir(io, input, output);

        io.close();
    }

}