//package sablon;

import java.io.IOException;
import java.lang.Math;
import java.io.PrintStream;

import mester.IO;


public class feladat {

    public feladat() {
    }

    static final int MaxN = 100;

	static class Film {
        int k;  // percekben mért (napbeli) idő óra*60+perc
        int v;  // percekben mért (napbeli) idő óra*60+perc
    }
	
	static class Input {
        int N;
        Film[] F;
    }

    static class Output {
        int Db;
		int[] X;
        int M;
		int[] Kezd;
		int[] S;
    }

    static Input beolvas(IO io) throws IOException {
        Input input = new Input();
        input.N = io.nextInt();
		input.F=new Film[input.N];
		for (int i=0;i<input.N;i++) {
			input.F[i]=new Film();
			int o=io.nextInt();
			int p=io.nextInt();
			input.F[i].k=o*60+p;
			o=io.nextInt();
			p=io.nextInt();
			input.F[i].v=o*60+p;
		}
        return input;
    }
	
	static void kiir(IO io, Input input, Output output) throws IOException {
		io.writeLn(output.Db);
		for (int i=0;i<output.Db;i++) {
			io.write(output.X[i]+1+" ");
		}
    }
	
	static int Max(Input input) {
		int mx=0;
		for (int i=0;i<input.N;i++) {
			if (mx<input.F[i].v) {
				mx=input.F[i].v;
			}
		}
		return mx;
	}
	
	static void Kezdetek(Input input, Output output) {
		output.Kezd=new int[output.M];
		output.S=new int[output.M];
		for (int i=0;i<output.M;i++) {
			output.Kezd[i]=-1;
			output.S[i]=-1;
		}
		for (int i=0;i<input.N;i++) {
			if (input.F[i].k>output.Kezd[input.F[i].v-1]) {
				output.Kezd[input.F[i].v-1]=input.F[i].k;
				output.S[input.F[i].v-1]=i;
			}
		}
	}

	static Output Kivalogatas(Input input) {
		Output output = new Output();
		output.M=Max(input);
		output.Db=0;
		int ido=0;
		output.X=new int[input.N];
		Kezdetek(input,output);
		for (int i=0;i<output.M;i++) {
			if ((output.S[i]!=-1) && (ido<=output.Kezd[i])) {
				output.X[output.Db]=output.S[i];
				output.Db++;
				ido=i;
			}
		}
		return output;
	}
   
    public static void main(String[] args) throws Exception {
        IO io = new IO();

        Input input = beolvas(io);

        Output output = Kivalogatas(input);

        kiir(io, input, output);

        io.close();
    }

}