/*
Feladat:
Egy kbelhlzat klnbz csatornin N filmet jtszanak. 
Ismerjk mindegyik film kezdsi s vgidejt. 
Egyszerre csak 1 filmet tudunk nzni. 
Add meg, hogy maximum hny filmet nzhetnk vgig s melyeket!
*/

#include <iostream>

using namespace std;

const int MAXN = 100;
const int MAXM = 24 * 60;


//kezd-, vgid s eredeti sorszm
struct Film {
	//percekben mrt (napbeli) id ra*60+perc
	int k, v;
};

void beolvasas(int& n, Film f[]) {
	cerr << "Filmek szama (0.." << MAXN << "):";
    //A bemenetet nem ellenrizzk sem szintaktikai, sem szemantikai szempontbl.
    cin >> n; //0<=N<=MaxN
    for (int i = 0; i < n; i++) {
		cerr << i + 1 << ". film kezdo es vegideje (ora perc):";
		int o, p;
		cin >> o >> p;
		f[i].k = o * 60 + p;
		cin >> o >> p;
		f[i].v = o * 60 + p;
	}
}

int max(const int& n, Film f[]) {
	int mx = 0;
    for (int i = 0; i < n; i++) {
		if (f[i].v > mx) {
			mx = f[i].v;
		}
	}
    return mx;
}

void kezdetek(const int& n, const int& m, Film f[], int kezd[], int s[]) {
	for (int i = 1; i <= m; i++) {
		kezd[i] = 0;
		s[i] = 0;
	}
	for (int i = 0; i < n; i++) {
		if (f[i].k > kezd[f[i].v]) {
			kezd[f[i].v] = f[i].k;
			s[f[i].v] = i + 1;
		}
	}
}

void kivalogatas(const int& n, Film f[], int& db, int x[]) {
	int m = max(n, f); //a legutols vgs id (percekben)
    db = 0;
	int ido = 0;
	int kezd[MAXM], s[MAXM];
	kezdetek(n, m, f, kezd, s);
    for (int i = 1; i <= m; i++) {
		if (s[i] != 0 && ido <= kezd[i]) {
			x[db++] = s[i];
			ido = i;
		}
	}
}

void kiiras(const int& db, int x[]) {
	cerr << "A megnezendo filmek szama:";
	cout << db; 
    cerr << "A megnezendo filmek sorszama:"; 
    for (int i = 0; i < db; i++) {
		cout << x[i] << " ";
	}
    cout << endl;
}

int main() {
	
	int n, db, x[MAXN];
	Film f[MAXN];
	
	beolvasas(n, f);
	kivalogatas(n, f, db, x);
	kiiras(db, x);
	
}