Program Filmek_Moho_1;
(*
  Feladat:
  * Egy kábelhálózat különböző csatornáin N filmet játszanak. 
  * Ismerjük mindegyik film kezdési és végidejét. 
  * Egyszerre csak 1 filmet tudunk nézni. 
  * Add meg, hogy maximum hány filmet nézhetünk végig és melyeket!
*)
  Const
    MaxN=100;
    MaxM=24*60;
  Type
    TIdo=Integer;//percekben mért (napbeli) idő óra*60+perc
    TFilm=Record k,v:TIdo End;//kezdő-, végidő (percekben mérve)
    TFilmek=Array [1..MaxN] of TFilm;
    TEgeszek=Array [1..MaxM] of Integer;
  Var
    N:Integer;
    F:TFilmek;
    Db:Integer;
    X:TEgeszek;//a megnézendő filmek sorszámai

  Procedure Beolvasas(Var N:Integer; Var F:TFilmek);
    Var
      i,o,p:integer;
  Begin
    //A felhasználónak szánt tájékoztató üzenetek az StrErr csatotnára írandók!
    //Például a kérdések:
    Write(StdErr,'Filmek szama (0..',MaxN,'):');
    //A bemenetet nem ellenőrizzük sem szintaktikai, sem szemantikai szempontból.
    Readln(N);//0<=N<=MaxN
    For i:=1 to N do
    Begin
      Write(StdErr,i:3,'. film kezdo es vegideje (ora perc):'); 
      Read(o,p); F[i].k:=o*60+p;
      Readln(o,p); F[i].v:=o*60+p;
    End;
  End;

  Procedure Kivalogatas(Const N:Integer; Var F:TFilmek; 
                        Var Db:Integer; Var X:TEgeszek);
    Var
      i,j,
      M,ido:Integer;
      Kezd,S:TEgeszek;
      
    Procedure Kezdetek(Const N,M:Integer; Const F:TFilmek; Var Kezd,S:TEgeszek);
      Var
        i:Integer;
    Begin
      For i:=1 to M do
      Begin
        Kezd[i]:=0; S[i]:=0; 
      End;
      For i:=1 to N do
      Begin
        If F[i].k>Kezd[F[i].v] then
        Begin
          Kezd[F[i].v]:=F[i].k; S[F[i].v]:=i;
        End;
      End;
    End;//Kezdetek
    
    Function Max(Const N:Integer; Const F:TFilmek):Integer;//a legutolsó végső idő (percekben)
      Var
        i,mx:Integer;
    Begin
      mx:=0;
      For i:=1 to N do
      Begin
        If F[i].v>mx then mx:=F[i].v;
      End;
      Max:=mx;
    End;//Max
    
  Begin//Kivalogatas
    M:=Max(N,F);//a legutolsó végső idő (percekben)
    Db:=0; ido:=0; Kezdetek(N,M,F,Kezd,S);
    For i:=1 to M do
    Begin
      If (S[i]<>0) and (ido<=Kezd[i]) then
      Begin
        Inc(Db); X[Db]:=S[i]; ido:=i;
      End;
    End;
  End;

  Procedure Kiiras(Const N:Integer; Const X:TEgeszek);
    Var
      i:Integer;
  Begin
    //A kimenetet kísérő szövegek is az StdErr-re irandók!
    Write(StdErr,'A megnezendo filmek szama:'); Writeln(Db); 
    Write(StdErr,'A megnezendo filmek sorszama:'); 
    For i:=1 to Db do
    Begin
	  Write(X[i],' ');
    End;
    Writeln; 
  End;
  
Begin
  Beolvasas(N,F);
  Kivalogatas(N,F,Db,X);
  Kiiras(N,X);
End.
